﻿namespace AirFighter
{
    internal static class ExtentionAircraft
    {
        private static readonly char _separatorForObject = ':';
        public static DrawingAirFighter CreateDrawingAirFighter(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawingAirFighter(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 6)
            {
                return new DrawingModernAirFighter(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
               Convert.ToBoolean(strs[5]));
            }
            return null;
        }
        public static string GetDataForSave(this DrawingAirFighter drawningAircraft)
        {
            var aircraft = drawningAircraft.AirFighter;
            var str = 
                $"{aircraft.Speed}{_separatorForObject}{aircraft.Weight}{_separatorForObject}" +
                $"{aircraft.BodyColor.Name}";

            if (aircraft is not EntityModernAirFighter modernAircraft)
            {
                return str;
            }
            return
           $"{str}{_separatorForObject}{modernAircraft.DopColor.Name}{_separatorForObject}" +
           $"{modernAircraft.Rockets}{_separatorForObject}{modernAircraft.DopWings}";
        }
    }
}