﻿namespace AirFighter
{
    /// <summary>
    /// Форма создания объекта
    /// </summary>
    public partial class FormAircraftConfig : Form
    {
        /// <summary>
        /// Переменная-выбранная машина
        /// </summary>
        DrawingAirFighter _car = null;

        private Action<DrawingAirFighter> EventAddCar = null;
        /// <summary>
        /// Событие
        /// </summary>
        //  private event CarDelegate EventAddCar;
        /// <summary>
        /// Конструктор
        /// </summary>
        public FormAircraftConfig()
        {
            InitializeComponent();
            panelBlack.MouseDown += PanelColor_MouseDown;
            panelPurple.MouseDown += PanelColor_MouseDown;
            panelGray.MouseDown += PanelColor_MouseDown;
            panelGreen.MouseDown += PanelColor_MouseDown;
            panelRed.MouseDown += PanelColor_MouseDown;
            panelWhite.MouseDown += PanelColor_MouseDown;
            panelYellow.MouseDown += PanelColor_MouseDown;
            panelBlue.MouseDown += PanelColor_MouseDown;
            // TODO buttonCancel.Click with lambda

            buttonCancel.Click += (s, e) => Close();
            
        }
        /// <summary>
        /// Отрисовать машину
        /// </summary>
        
        public void AddEvent(Action<DrawingAirFighter> ev)
        {
            if(EventAddCar == null)
            {
                EventAddCar = ev;
                return;
            }

            EventAddCar += ev;
        }

        private void DrawCar()
        {
            Bitmap bmp = new(pictureBoxObject.Width, pictureBoxObject.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _car?.SetPosition(5, 5, pictureBoxObject.Width,
           pictureBoxObject.Height);
            _car?.DrawTransport(gr);
            pictureBoxObject.Image = bmp;
        }
        /// <summary>
        /// Добавление события
        /// </summary>
        /// <param name="ev"></param>
/*        public void AddEvent(CarDelegate ev)
        {
            if (EventAddCar == null)
            {
                EventAddCar = new CarDelegate(ev);
            }
            else
            {
                EventAddCar += ev;
            }
        }*/
        /// <summary>
        /// Передаем информацию при нажатии на Label
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LabelObject_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Label).DoDragDrop((sender as Label).Name,
           DragDropEffects.Move | DragDropEffects.Copy);
        }
        /// <summary>
        /// Проверка получаемой информации (ее типа на соответствие требуемому)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PanelObject_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }
        /// <summary>
        /// Действия при приеме перетаскиваемой информации
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PanelObject_DragDrop(object sender, DragEventArgs e)
        {
            switch (e.Data.GetData(DataFormats.Text).ToString())
            {
                case "labelSimpleObject":
                    _car = new DrawingAirFighter((int)numericUpDownSpeed.Value,
                   (int)numericUpDownWeight.Value, Color.White);
                    break;
                case "labelModifiedObject":
                    _car = new DrawingModernAirFighter((int)numericUpDownSpeed.Value,
                   (int)numericUpDownWeight.Value, Color.White, Color.Black,
                    checkBoxDopWings.Checked, checkBoxRockets.Checked);
                    break;
            }
            DrawCar();
        }
        /// <summary>
        /// Отправляем цвет с панели
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PanelColor_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Control).DoDragDrop((sender as Control).BackColor,
           DragDropEffects.Move | DragDropEffects.Copy);
        }
        /// <summary>
        private void LabelColor_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(Color)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        /// Принимаем основной цвет
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LabelBaseColor_DragDrop(object sender, DragEventArgs e)
        {
            if (_car == null) return;
            Color color = (Color)e.Data.GetData(typeof(Color));

            if(_car is DrawingModernAirFighter)
            {
                _car = ((DrawingModernAirFighter)_car).Update(bodyColor: color);
            }
            else
            {
                _car = _car.Update(bodyColor: color);
            }
            DrawCar();
        }
        /// <summary>
        /// Принимаем дополнительный цвет
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LabelDopColor_DragDrop(object sender, DragEventArgs e)
        {
            var car = _car as DrawingModernAirFighter;
            if (car == null) return;

            Color color = (Color)e.Data.GetData(typeof(Color));
            _car = car.Update(dopColor: color);
            DrawCar();
        }
        /// <summary>
        /// Добавление машины
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonOk_Click(object sender, EventArgs e)
        {
            EventAddCar?.Invoke(_car);
            Close();
        }

    }
}
