﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFighter
{
    internal class SetCarsGeneric<T>
    where T : class
    {
        /// <summary>
        /// Список объектов, которые храним
        /// </summary>
        private readonly List<T> _places;
        /// <summary>
        /// Количество объектов в списке
        /// </summary>
        public int Count => _places.Count;
        private readonly int _maxCount;
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="count"></param>
        public SetCarsGeneric(int count)
        {
            _maxCount = count;
            _places = new List<T>();
        }
        public int Insert(T car)
        {
            // TODO вставка в начало набора
            if (_places.Count == _maxCount) return -1;
            _places.Insert(0, car);
            return 0;
        }
        public int Insert(T car, int position)
        {
            // TODO проверка позиции
            // TODO проверка, что элемент массива по этой позиции пустой, если нет, то
            // проверка, что после вставляемого элемента в массиве есть пустой элемент
            // сдвиг всех объектов, находящихся справа от позиции до первого пустого элемента
            // TODO вставка по позиции
            if (_places.Count == _maxCount) return -1;
            _places.Insert(position, car);
            return position;
        }
        /// <summary>
        /// Удаление объекта из набора с конкретной позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T Remove(int position)
        {
            // TODO проверка позиции
            // TODO удаление объекта из массива, присовив элементу массива значение null
            T res = _places[position];
            _places.Remove(res);
            return res;
        }
        /// <summary>
        /// Получение объекта из набора по позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T this[int position]
        {
            get
            {
                // TODO проверка позиции
                if(position < 0) return null;
                if(position >= _places.Count) return null;
                return _places[position];
            }
            set
            {
                // TODO проверка позиции
                if (position < 0) return;
                if (position >= _places.Count) return;
                // TODO вставка в список по позиции
                Insert(value, position);
            }
        }

        public IEnumerable<T> GetCars()
        {
            foreach (var car in _places)
            {
                if (car != null)
                {
                    yield return car;
                }
                else
                {
                    yield break;
                }
            }
        }
    }
}
